<?php

namespace Bank\Mellat\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for bpDynamicPayRequest StructType
 * Meta information extracted from the WSDL
 * - type: tns:bpDynamicPayRequest
 * @subpackage Structs
 */
class BpDynamicPayRequest extends AbstractStructBase
{
    /**
     * The terminalId
     * @var int
     */
    public $terminalId;
    /**
     * The userName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userName;
    /**
     * The userPassword
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userPassword;
    /**
     * The orderId
     * @var int
     */
    public $orderId;
    /**
     * The amount
     * @var int
     */
    public $amount;
    /**
     * The localDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $localDate;
    /**
     * The localTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $localTime;
    /**
     * The additionalData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $additionalData;
    /**
     * The callBackUrl
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $callBackUrl;
    /**
     * The payerId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $payerId;
    /**
     * The subServiceId
     * @var int
     */
    public $subServiceId;
    /**
     * The mobileNo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mobileNo;
    /**
     * The encPan
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $encPan;
    /**
     * The panHiddenMode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $panHiddenMode;
    /**
     * The cartItem
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $cartItem;
    /**
     * The enc
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $enc;
    /**
     * Constructor method for bpDynamicPayRequest
     * @uses BpDynamicPayRequest::setTerminalId()
     * @uses BpDynamicPayRequest::setUserName()
     * @uses BpDynamicPayRequest::setUserPassword()
     * @uses BpDynamicPayRequest::setOrderId()
     * @uses BpDynamicPayRequest::setAmount()
     * @uses BpDynamicPayRequest::setLocalDate()
     * @uses BpDynamicPayRequest::setLocalTime()
     * @uses BpDynamicPayRequest::setAdditionalData()
     * @uses BpDynamicPayRequest::setCallBackUrl()
     * @uses BpDynamicPayRequest::setPayerId()
     * @uses BpDynamicPayRequest::setSubServiceId()
     * @uses BpDynamicPayRequest::setMobileNo()
     * @uses BpDynamicPayRequest::setEncPan()
     * @uses BpDynamicPayRequest::setPanHiddenMode()
     * @uses BpDynamicPayRequest::setCartItem()
     * @uses BpDynamicPayRequest::setEnc()
     * @param int $terminalId
     * @param string $userName
     * @param string $userPassword
     * @param int $orderId
     * @param int $amount
     * @param string $localDate
     * @param string $localTime
     * @param string $additionalData
     * @param string $callBackUrl
     * @param string $payerId
     * @param int $subServiceId
     * @param string $mobileNo
     * @param string $encPan
     * @param string $panHiddenMode
     * @param string $cartItem
     * @param string $enc
     */
    public function __construct($terminalId = null, $userName = null, $userPassword = null, $orderId = null, $amount = null, $localDate = null, $localTime = null, $additionalData = null, $callBackUrl = null, $payerId = null, $subServiceId = null, $mobileNo = null, $encPan = null, $panHiddenMode = null, $cartItem = null, $enc = null)
    {
        $this
            ->setTerminalId($terminalId)
            ->setUserName($userName)
            ->setUserPassword($userPassword)
            ->setOrderId($orderId)
            ->setAmount($amount)
            ->setLocalDate($localDate)
            ->setLocalTime($localTime)
            ->setAdditionalData($additionalData)
            ->setCallBackUrl($callBackUrl)
            ->setPayerId($payerId)
            ->setSubServiceId($subServiceId)
            ->setMobileNo($mobileNo)
            ->setEncPan($encPan)
            ->setPanHiddenMode($panHiddenMode)
            ->setCartItem($cartItem)
            ->setEnc($enc);
    }
    /**
     * Get terminalId value
     * @return int|null
     */
    public function getTerminalId()
    {
        return $this->terminalId;
    }
    /**
     * Set terminalId value
     * @param int $terminalId
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setTerminalId($terminalId = null)
    {
        // validation for constraint: int
        if (!is_null($terminalId) && !(is_int($terminalId) || ctype_digit($terminalId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($terminalId, true), gettype($terminalId)), __LINE__);
        }
        $this->terminalId = $terminalId;
        return $this;
    }
    /**
     * Get userName value
     * @return string|null
     */
    public function getUserName()
    {
        return $this->userName;
    }
    /**
     * Set userName value
     * @param string $userName
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setUserName($userName = null)
    {
        // validation for constraint: string
        if (!is_null($userName) && !is_string($userName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userName, true), gettype($userName)), __LINE__);
        }
        $this->userName = $userName;
        return $this;
    }
    /**
     * Get userPassword value
     * @return string|null
     */
    public function getUserPassword()
    {
        return $this->userPassword;
    }
    /**
     * Set userPassword value
     * @param string $userPassword
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setUserPassword($userPassword = null)
    {
        // validation for constraint: string
        if (!is_null($userPassword) && !is_string($userPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userPassword, true), gettype($userPassword)), __LINE__);
        }
        $this->userPassword = $userPassword;
        return $this;
    }
    /**
     * Get orderId value
     * @return int|null
     */
    public function getOrderId()
    {
        return $this->orderId;
    }
    /**
     * Set orderId value
     * @param int $orderId
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setOrderId($orderId = null)
    {
        // validation for constraint: int
        if (!is_null($orderId) && !(is_int($orderId) || ctype_digit($orderId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($orderId, true), gettype($orderId)), __LINE__);
        }
        $this->orderId = $orderId;
        return $this;
    }
    /**
     * Get amount value
     * @return int|null
     */
    public function getAmount()
    {
        return $this->amount;
    }
    /**
     * Set amount value
     * @param int $amount
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: int
        if (!is_null($amount) && !(is_int($amount) || ctype_digit($amount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($amount, true), gettype($amount)), __LINE__);
        }
        $this->amount = $amount;
        return $this;
    }
    /**
     * Get localDate value
     * @return string|null
     */
    public function getLocalDate()
    {
        return $this->localDate;
    }
    /**
     * Set localDate value
     * @param string $localDate
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setLocalDate($localDate = null)
    {
        // validation for constraint: string
        if (!is_null($localDate) && !is_string($localDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($localDate, true), gettype($localDate)), __LINE__);
        }
        $this->localDate = $localDate;
        return $this;
    }
    /**
     * Get localTime value
     * @return string|null
     */
    public function getLocalTime()
    {
        return $this->localTime;
    }
    /**
     * Set localTime value
     * @param string $localTime
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setLocalTime($localTime = null)
    {
        // validation for constraint: string
        if (!is_null($localTime) && !is_string($localTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($localTime, true), gettype($localTime)), __LINE__);
        }
        $this->localTime = $localTime;
        return $this;
    }
    /**
     * Get additionalData value
     * @return string|null
     */
    public function getAdditionalData()
    {
        return $this->additionalData;
    }
    /**
     * Set additionalData value
     * @param string $additionalData
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setAdditionalData($additionalData = null)
    {
        // validation for constraint: string
        if (!is_null($additionalData) && !is_string($additionalData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($additionalData, true), gettype($additionalData)), __LINE__);
        }
        $this->additionalData = $additionalData;
        return $this;
    }
    /**
     * Get callBackUrl value
     * @return string|null
     */
    public function getCallBackUrl()
    {
        return $this->callBackUrl;
    }
    /**
     * Set callBackUrl value
     * @param string $callBackUrl
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setCallBackUrl($callBackUrl = null)
    {
        // validation for constraint: string
        if (!is_null($callBackUrl) && !is_string($callBackUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callBackUrl, true), gettype($callBackUrl)), __LINE__);
        }
        $this->callBackUrl = $callBackUrl;
        return $this;
    }
    /**
     * Get payerId value
     * @return string|null
     */
    public function getPayerId()
    {
        return $this->payerId;
    }
    /**
     * Set payerId value
     * @param string $payerId
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setPayerId($payerId = null)
    {
        // validation for constraint: string
        if (!is_null($payerId) && !is_string($payerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($payerId, true), gettype($payerId)), __LINE__);
        }
        $this->payerId = $payerId;
        return $this;
    }
    /**
     * Get subServiceId value
     * @return int|null
     */
    public function getSubServiceId()
    {
        return $this->subServiceId;
    }
    /**
     * Set subServiceId value
     * @param int $subServiceId
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setSubServiceId($subServiceId = null)
    {
        // validation for constraint: int
        if (!is_null($subServiceId) && !(is_int($subServiceId) || ctype_digit($subServiceId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($subServiceId, true), gettype($subServiceId)), __LINE__);
        }
        $this->subServiceId = $subServiceId;
        return $this;
    }
    /**
     * Get mobileNo value
     * @return string|null
     */
    public function getMobileNo()
    {
        return $this->mobileNo;
    }
    /**
     * Set mobileNo value
     * @param string $mobileNo
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setMobileNo($mobileNo = null)
    {
        // validation for constraint: string
        if (!is_null($mobileNo) && !is_string($mobileNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mobileNo, true), gettype($mobileNo)), __LINE__);
        }
        $this->mobileNo = $mobileNo;
        return $this;
    }
    /**
     * Get encPan value
     * @return string|null
     */
    public function getEncPan()
    {
        return $this->encPan;
    }
    /**
     * Set encPan value
     * @param string $encPan
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setEncPan($encPan = null)
    {
        // validation for constraint: string
        if (!is_null($encPan) && !is_string($encPan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($encPan, true), gettype($encPan)), __LINE__);
        }
        $this->encPan = $encPan;
        return $this;
    }
    /**
     * Get panHiddenMode value
     * @return string|null
     */
    public function getPanHiddenMode()
    {
        return $this->panHiddenMode;
    }
    /**
     * Set panHiddenMode value
     * @param string $panHiddenMode
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setPanHiddenMode($panHiddenMode = null)
    {
        // validation for constraint: string
        if (!is_null($panHiddenMode) && !is_string($panHiddenMode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($panHiddenMode, true), gettype($panHiddenMode)), __LINE__);
        }
        $this->panHiddenMode = $panHiddenMode;
        return $this;
    }
    /**
     * Get cartItem value
     * @return string|null
     */
    public function getCartItem()
    {
        return $this->cartItem;
    }
    /**
     * Set cartItem value
     * @param string $cartItem
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setCartItem($cartItem = null)
    {
        // validation for constraint: string
        if (!is_null($cartItem) && !is_string($cartItem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cartItem, true), gettype($cartItem)), __LINE__);
        }
        $this->cartItem = $cartItem;
        return $this;
    }
    /**
     * Get enc value
     * @return string|null
     */
    public function getEnc()
    {
        return $this->enc;
    }
    /**
     * Set enc value
     * @param string $enc
     * @return \Bank\Mellat\StructType\BpDynamicPayRequest
     */
    public function setEnc($enc = null)
    {
        // validation for constraint: string
        if (!is_null($enc) && !is_string($enc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($enc, true), gettype($enc)), __LINE__);
        }
        $this->enc = $enc;
        return $this;
    }
}
