<?php

namespace Bank\Mellat\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for bpInquiryRequest StructType
 * Meta information extracted from the WSDL
 * - type: tns:bpInquiryRequest
 * @subpackage Structs
 */
class BpInquiryRequest extends AbstractStructBase
{
    /**
     * The terminalId
     * @var int
     */
    public $terminalId;
    /**
     * The userName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userName;
    /**
     * The userPassword
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userPassword;
    /**
     * The orderId
     * @var int
     */
    public $orderId;
    /**
     * The saleOrderId
     * @var int
     */
    public $saleOrderId;
    /**
     * The saleReferenceId
     * @var int
     */
    public $saleReferenceId;
    /**
     * Constructor method for bpInquiryRequest
     * @uses BpInquiryRequest::setTerminalId()
     * @uses BpInquiryRequest::setUserName()
     * @uses BpInquiryRequest::setUserPassword()
     * @uses BpInquiryRequest::setOrderId()
     * @uses BpInquiryRequest::setSaleOrderId()
     * @uses BpInquiryRequest::setSaleReferenceId()
     * @param int $terminalId
     * @param string $userName
     * @param string $userPassword
     * @param int $orderId
     * @param int $saleOrderId
     * @param int $saleReferenceId
     */
    public function __construct($terminalId = null, $userName = null, $userPassword = null, $orderId = null, $saleOrderId = null, $saleReferenceId = null)
    {
        $this
            ->setTerminalId($terminalId)
            ->setUserName($userName)
            ->setUserPassword($userPassword)
            ->setOrderId($orderId)
            ->setSaleOrderId($saleOrderId)
            ->setSaleReferenceId($saleReferenceId);
    }
    /**
     * Get terminalId value
     * @return int|null
     */
    public function getTerminalId()
    {
        return $this->terminalId;
    }
    /**
     * Set terminalId value
     * @param int $terminalId
     * @return \Bank\Mellat\StructType\BpInquiryRequest
     */
    public function setTerminalId($terminalId = null)
    {
        // validation for constraint: int
        if (!is_null($terminalId) && !(is_int($terminalId) || ctype_digit($terminalId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($terminalId, true), gettype($terminalId)), __LINE__);
        }
        $this->terminalId = $terminalId;
        return $this;
    }
    /**
     * Get userName value
     * @return string|null
     */
    public function getUserName()
    {
        return $this->userName;
    }
    /**
     * Set userName value
     * @param string $userName
     * @return \Bank\Mellat\StructType\BpInquiryRequest
     */
    public function setUserName($userName = null)
    {
        // validation for constraint: string
        if (!is_null($userName) && !is_string($userName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userName, true), gettype($userName)), __LINE__);
        }
        $this->userName = $userName;
        return $this;
    }
    /**
     * Get userPassword value
     * @return string|null
     */
    public function getUserPassword()
    {
        return $this->userPassword;
    }
    /**
     * Set userPassword value
     * @param string $userPassword
     * @return \Bank\Mellat\StructType\BpInquiryRequest
     */
    public function setUserPassword($userPassword = null)
    {
        // validation for constraint: string
        if (!is_null($userPassword) && !is_string($userPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userPassword, true), gettype($userPassword)), __LINE__);
        }
        $this->userPassword = $userPassword;
        return $this;
    }
    /**
     * Get orderId value
     * @return int|null
     */
    public function getOrderId()
    {
        return $this->orderId;
    }
    /**
     * Set orderId value
     * @param int $orderId
     * @return \Bank\Mellat\StructType\BpInquiryRequest
     */
    public function setOrderId($orderId = null)
    {
        // validation for constraint: int
        if (!is_null($orderId) && !(is_int($orderId) || ctype_digit($orderId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($orderId, true), gettype($orderId)), __LINE__);
        }
        $this->orderId = $orderId;
        return $this;
    }
    /**
     * Get saleOrderId value
     * @return int|null
     */
    public function getSaleOrderId()
    {
        return $this->saleOrderId;
    }
    /**
     * Set saleOrderId value
     * @param int $saleOrderId
     * @return \Bank\Mellat\StructType\BpInquiryRequest
     */
    public function setSaleOrderId($saleOrderId = null)
    {
        // validation for constraint: int
        if (!is_null($saleOrderId) && !(is_int($saleOrderId) || ctype_digit($saleOrderId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($saleOrderId, true), gettype($saleOrderId)), __LINE__);
        }
        $this->saleOrderId = $saleOrderId;
        return $this;
    }
    /**
     * Get saleReferenceId value
     * @return int|null
     */
    public function getSaleReferenceId()
    {
        return $this->saleReferenceId;
    }
    /**
     * Set saleReferenceId value
     * @param int $saleReferenceId
     * @return \Bank\Mellat\StructType\BpInquiryRequest
     */
    public function setSaleReferenceId($saleReferenceId = null)
    {
        // validation for constraint: int
        if (!is_null($saleReferenceId) && !(is_int($saleReferenceId) || ctype_digit($saleReferenceId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($saleReferenceId, true), gettype($saleReferenceId)), __LINE__);
        }
        $this->saleReferenceId = $saleReferenceId;
        return $this;
    }
}
